/*
mlp_nn_lmn.hh

This C++ header file defines the NML Messages used for command and status by MLP_NN_LM_MODULE
Template Version 1.1

MODIFICATIONS:
Fri Dec 22 17:42:35 EST 2000	Created by rcsdesign.

*/

// Prevent Multiple Inclusion
#ifndef MLP_NN_LMN_HH
#define MLP_NN_LMN_HH

// Include Files
#include "rcs.hh" 	// Common RCS definitions

// Predefined type files
// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.
#define NUM_OF_INPUTS 2
#define NUM_OF_OUTPUTS 2
#define NUM_OF_NEURONS 10
#define NUM_OF_DATA 100


// Define the integer type ids.
//  RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

#define MLP_NN_LM_STATUS_TYPE 1000
#define MLP_NN_LM_HALT_TYPE 1001
#define MLP_NN_LM_INIT_TYPE 1002
#define MLP_NN_LM_SET_ACTIVATION_FUNCTION_TYPE_TYPE 1003
#define MLP_NN_LM_SET_INPUT_BIASES_TYPE 1004
#define MLP_NN_LM_SET_INPUT_GAINS_TYPE 1005
#define MLP_NN_LM_SET_NONSINGULARITY_PARAM_TYPE 1006
#define MLP_NN_LM_SET_OUTPUT_BIASES_TYPE 1007
#define MLP_NN_LM_SET_OUTPUT_GAINS_TYPE 1008
#define MLP_NN_LM_TEST_TYPE 1009
#define MLP_NN_LM_TRAIN_TYPE 1010
//  RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


// Define the NML Message Classes

// Status Class
class MLP_NN_LM_STATUS : public RCS_STAT_MSG
{
public:

	// Normal Constructor
	MLP_NN_LM_STATUS();

	// Constructor used by derived classes
	MLP_NN_LM_STATUS(NMLTYPE t, size_t s) :  RCS_STAT_MSG(t,s) {};

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  double sys_inputs[NUM_OF_INPUTS];
  double sys_outputs[NUM_OF_OUTPUTS];

  double output_errors[NUM_OF_OUTPUTS];

  int activation_function_type;

};

// Command Classes

class MLP_NN_LM_HALT : public RCS_CMD_MSG
{
public:

	//Constructor
	MLP_NN_LM_HALT();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.

};

class MLP_NN_LM_INIT : public RCS_CMD_MSG
{
public:

	//Constructor
	MLP_NN_LM_INIT();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.

};

class MLP_NN_LM_SET_ACTIVATION_FUNCTION_TYPE : public RCS_CMD_MSG
{
public:

	//Constructor
	MLP_NN_LM_SET_ACTIVATION_FUNCTION_TYPE();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  int activation_function_type;

};

class MLP_NN_LM_SET_INPUT_BIASES : public RCS_CMD_MSG
{
public:

	//Constructor
	MLP_NN_LM_SET_INPUT_BIASES();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  double low_bound;
  double high_bound;

};

class MLP_NN_LM_SET_INPUT_GAINS : public RCS_CMD_MSG
{
public:

	//Constructor
	MLP_NN_LM_SET_INPUT_GAINS();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  double low_bound;
  double high_bound;

};

class MLP_NN_LM_SET_NONSINGULARITY_PARAM : public RCS_CMD_MSG
{
public:

	//Constructor
	MLP_NN_LM_SET_NONSINGULARITY_PARAM();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  double nonsingularity_param;

};

class MLP_NN_LM_SET_OUTPUT_BIASES : public RCS_CMD_MSG
{
public:

	//Constructor
	MLP_NN_LM_SET_OUTPUT_BIASES();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  double low_bound;
  double high_bound;

};

class MLP_NN_LM_SET_OUTPUT_GAINS : public RCS_CMD_MSG
{
public:

	//Constructor
	MLP_NN_LM_SET_OUTPUT_GAINS();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  double low_bound;
  double high_bound;

};

class MLP_NN_LM_TEST : public RCS_CMD_MSG
{
public:

	//Constructor
	MLP_NN_LM_TEST();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.

};

class MLP_NN_LM_TRAIN : public RCS_CMD_MSG
{
public:

	//Constructor
	MLP_NN_LM_TRAIN();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  double tolerance;
  double min_grad_norm;
};

// Declare NML format function
extern int mlp_nn_lmFormat(NMLTYPE, void *, CMS *);

#endif 	// MLP_NN_LMN_HH
