/*
	mlp_lm_modulesvr.cc

	This C++ file provides a main routin to start an NML server for this application
	It connects to all of the NML channels used by this application.
	If they are all valid it will call run_nml_servers(), otherwise it will exit immediately.

	MODIFICATIONS:
	Fri Dec 22 17:42:36 EST 2000	Created.

*/

// Include Files
#include <stdlib.h> // exit()
#include "rcs.hh" 	// Common RCS definitions
#include "mlp_nn_lmn.hh" 	// mlp_nn_lmFormat

// NML Channel Pointers
static RCS_CMD_CHANNEL *mlp_nn_lm_cmd = NULL;
static RCS_STAT_CHANNEL *mlp_nn_lm_stat = NULL;
static NML *errlog = NULL;

static int InitNML()
{


	// mlp_nn_lm
	mlp_nn_lm_cmd = new RCS_CMD_CHANNEL(mlp_nn_lmFormat, "mlp_nn_lm_cmd", "mlp_lm_modulesvr", "mlp_lm_module.nml");
	if(NULL == mlp_nn_lm_cmd)
		return -1;
	if(!mlp_nn_lm_cmd->valid())
		return -1;

	mlp_nn_lm_stat = new RCS_STAT_CHANNEL(mlp_nn_lmFormat, "mlp_nn_lm_sts", "mlp_lm_modulesvr", "mlp_lm_module.nml");
	if(NULL == mlp_nn_lm_stat)
		return -1;
	if(!mlp_nn_lm_stat->valid())
		return -1;

	errlog = new NML(nmlErrorFormat, "errlog", "mlp_lm_modulesvr", "mlp_lm_module.nml");
	if(NULL == errlog)
		return -1;
	if(!errlog->valid())
		return -1;

	return 0;
}

static void DeleteNML()
{

	// mlp_nn_lm
	if(NULL != mlp_nn_lm_cmd)
	{
		delete mlp_nn_lm_cmd;
		mlp_nn_lm_cmd = NULL;
	}

	if(NULL != mlp_nn_lm_stat)
	{
		delete mlp_nn_lm_stat;
		mlp_nn_lm_stat = NULL;
	}

	if(NULL != errlog)
	{
		delete errlog;
		errlog = NULL;
	}

}

// Main 
#ifdef VXWORKS
extern "C" int mlp_lm_modulesvr_run();

int mlp_lm_modulesvr_run()
#else
int main(int argc, char **argv)
#endif
{

	set_rcs_print_destination(RCS_PRINT_TO_STDOUT);

	if(InitNML() < 0)
	{
		DeleteNML();
		rcs_exit(-1);
	}

	run_nml_servers();

}

