/*
mlp_nn_lm.cc

This C++ file defines member functions for the class MLP_NN_LM_MODULE
It was generated with rcsdesign
with template version 1.1

MODIFICATIONS:
Fri Dec 22 17:42:36 EST 2000	Created with RCS-Design tool.

*/

// Include Files
#include "rcs.hh" 	// Common RCS definitions
#include "nml_mod.hh" 	// NML_MODULE definitions
#include "mlp_nn_lm.hh" 	// MLP_NN_LM_MODULE definitions
// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.


#include "mlp_nn_lmn.hh" 	// NML Commands and Status definitions for mlp_nn_lm
// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


// Constructor
MLP_NN_LM_MODULE::MLP_NN_LM_MODULE(int _is_base_class)
{

	// Initialize the NML channels if this module is not being used as the base class for another module.
  if(!_is_base_class)
    {
      INITIALIZE_NML();
    }
  // Add additional code to initialize the module here.
  num_of_inputs = NUM_OF_INPUTS;
  num_of_outputs = NUM_OF_OUTPUTS;
  num_of_neurons = NUM_OF_NEURONS;
  num_of_data = NUM_OF_DATA;
  
  mlp_lm = new MLP_LM(num_of_inputs, num_of_outputs, num_of_neurons, num_of_data);
  
  if(mlp_lm->mlp_lm_err != MLP_LM_NO_ERROR)
    {
      logError("Error in creating MLP_NN_LM_MODULE object!!!");
      status = RCS_ERROR; // let my supervisor know I have a problem.
    }
  
  if ((batch_inputs = new double*[num_of_inputs]) == NULL)
    {
      logError("Error in creating RBF_NN_MODULE object!!!");
      status = RCS_ERROR; // let my supervisor know I have a problem.
    }
  for (int ii = 0; ii < num_of_inputs; ii++)
    {
      if ((batch_inputs[ii] = new double[num_of_data]) == NULL)
	{
	  logError("Error in creating KALMAN_FILTER_MODULE object!!!");
	  status = RCS_ERROR; // let my supervisor know I have a problem.
	}
    }
  
  if ((batch_ref_outputs = new double*[num_of_outputs]) == NULL)
    {
      logError("Error in creating RBF_NN_MODULE object!!!");
      status = RCS_ERROR; // let my supervisor know I have a problem.
    }
  for (int ii = 0; ii < num_of_outputs; ii++)
    {
      if ((batch_ref_outputs[ii] = new double[num_of_data]) == NULL)
	{
	  logError("Error in creating KALMAN_FILTER_MODULE object!!!");
	  status = RCS_ERROR; // let my supervisor know I have a problem.
	}
    }
  
  if ((temp1 = new double*[num_of_neurons]) == NULL)
    {
      logError("Error in creating RBF_NN_MODULE object!!!");
      status = RCS_ERROR; // let my supervisor know I have a problem.
    }
  for (int ii = 0; ii < num_of_neurons; ii++)
    {
      if ((temp1[ii] = new double[num_of_inputs]) == NULL)
	{
	  logError("Error in creating KALMAN_FILTER_MODULE object!!!");
	  status = RCS_ERROR; // let my supervisor know I have a problem.
	}
    }
  
  if ((temp2 = new double*[num_of_outputs]) == NULL)
    {
      logError("Error in creating RBF_NN_MODULE object!!!");
      status = RCS_ERROR; // let my supervisor know I have a problem.
    }
  for (int ii = 0; ii < num_of_outputs; ii++)
    {
      if ((temp2[ii] = new double[num_of_neurons]) == NULL)
	{
	  logError("Error in creating KALMAN_FILTER_MODULE object!!!");
	  status = RCS_ERROR; // let my supervisor know I have a problem.
	}
    }
  
}

// Overloaded Virtual Functions

/*
INITIALIZE_NML

The INITIALIZE_NML function is ussually called only once from within the
constructor. It should not be called if a derived class will also call it.

*/
void MLP_NN_LM_MODULE::INITIALIZE_NML()
{
	// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

	setErrorLogChannel(new NML(nmlErrorFormat, "errlog", "mlp_nn_lm", "mlp_lm_module.nml"));
	setCmdChannel(new RCS_CMD_CHANNEL(mlp_nn_lmFormat, "mlp_nn_lm_cmd", "mlp_nn_lm", "mlp_lm_module.nml"));
	mlp_nn_lm_status = new MLP_NN_LM_STATUS();
	setStatChannel(new RCS_STAT_CHANNEL(mlp_nn_lmFormat, "mlp_nn_lm_sts", "mlp_nn_lm", "mlp_lm_module.nml"), mlp_nn_lm_status);
	// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


}

/*
PRE_PROCESS

The PRE_PROCESS function is called every cycle after the command and
subordinates status have been read but before DECISION_PROCESS is called.
It is intended to be used for tasks such as sensory processing that should
be performed every cycle regardless of the current command or state.
*/
void MLP_NN_LM_MODULE::PRE_PROCESS()
{
	// Pre-Processing Code
  // Read and/or calculate inputs to the MLP NN
  // Here we just assign them to zero

  // System inputs
  for(int ii = 0; ii < num_of_inputs; ii++)
    {
      sys_inputs[ii] = 0.0;
    }

  // Read and/or calculate the reference outputs 
  // Here we just assign them to zero
  for(int ii = 0; ii < num_of_outputs; ii++)
    {
      ref_outputs[ii] = 0.0;
    }

  // Read and/or calculate the output errors 
  // Here we just assign them to zero
  for(int ii = 0; ii < num_of_outputs; ii++)
    {
      output_errors[ii] = 0.0;
    }

}

/*
DECISION_PROCESS

The DECISION_PROCESS function is called every cycle as long as there is a non-zero command.
It is expected to call a command function based on commandInData->type.
*/
void MLP_NN_LM_MODULE::DECISION_PROCESS()
{
	switch(commandInData->type)
	{
		// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

	case MLP_NN_LM_INIT_TYPE:
		INIT((MLP_NN_LM_INIT *)commandInData);
		break;

	case MLP_NN_LM_HALT_TYPE:
		HALT((MLP_NN_LM_HALT *)commandInData);
		break;

	case MLP_NN_LM_SET_ACTIVATION_FUNCTION_TYPE_TYPE:
		SET_ACTIVATION_FUNCTION_TYPE((MLP_NN_LM_SET_ACTIVATION_FUNCTION_TYPE *)commandInData);
		break;

	case MLP_NN_LM_SET_INPUT_BIASES_TYPE:
		SET_INPUT_BIASES((MLP_NN_LM_SET_INPUT_BIASES *)commandInData);
		break;

	case MLP_NN_LM_SET_INPUT_GAINS_TYPE:
		SET_INPUT_GAINS((MLP_NN_LM_SET_INPUT_GAINS *)commandInData);
		break;

	case MLP_NN_LM_SET_NONSINGULARITY_PARAM_TYPE:
		SET_NONSINGULARITY_PARAM((MLP_NN_LM_SET_NONSINGULARITY_PARAM *)commandInData);
		break;

	case MLP_NN_LM_SET_OUTPUT_BIASES_TYPE:
		SET_OUTPUT_BIASES((MLP_NN_LM_SET_OUTPUT_BIASES *)commandInData);
		break;

	case MLP_NN_LM_SET_OUTPUT_GAINS_TYPE:
		SET_OUTPUT_GAINS((MLP_NN_LM_SET_OUTPUT_GAINS *)commandInData);
		break;

	case MLP_NN_LM_TEST_TYPE:
		TEST((MLP_NN_LM_TEST *)commandInData);
		break;

	case MLP_NN_LM_TRAIN_TYPE:
		TRAIN((MLP_NN_LM_TRAIN *)commandInData);
		break;
		// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


	default:
		logError("The command %d is not recognized.",commandInData->type);
		break;
	}
}

/*
POST_PROCESS

The POST_PROCESS function is called every cycle after DECISION_PROCESS is called
but before the status and the subordinates commands  have been written.
It is intended to be used for tasks such as output filters that should
be performed every cycle regardless of the current command or state.
*/
void MLP_NN_LM_MODULE::POST_PROCESS()
{
	// Post-Processing Code

  // Report the current system inputs
  memcpy(mlp_nn_lm_status->sys_inputs, sys_inputs, 
         num_of_inputs*sizeof(double));

  // Report the current system outputs
  memcpy(mlp_nn_lm_status->sys_outputs, sys_outputs, 
         num_of_outputs*sizeof(double));

  // Report the current output errors
  memcpy(mlp_nn_lm_status->output_errors, output_errors, 
         num_of_outputs*sizeof(double));

  // Report the current activation function type used
  mlp_nn_lm_status->activation_function_type = 
    mlp_lm->get_activation_function_type();

}

// Command Functions

/*
INIT

Parameter(s):
MLP_NN_LM_INIT *cmd_in -- NML Message sent from superior.

Most Modules will have an INIT command.
The INIT function is expected to initialize any variables that may be
in an uninitialized or unknown state, send INIT commands to its subordinates,
wait for the subordinates to be DONE and then inform its superior that it is done.
The state tables should use the STATE_MATCH macro so the diagnostics tool can 
highlight the current line in the state table.
*/
void MLP_NN_LM_MODULE::INIT(MLP_NN_LM_INIT *cmd_in)
{
	// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

	// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


	if(STATE_MATCH(NEW_COMMAND))
	{
		// Send an INIT command to all subordinates.
		// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

		// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


		stateNext(S1);
		// Reinitialize variables here.

	}
	// Wait for all subordinates to report done.
	// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

	else if(STATE_MATCH(S1,
		1))
	// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.

	{
		status = RCS_DONE;
		stateNext(S2);
	}
	else if(STATE_MATCH(S2))
	{
		// Idle State
	}
}

/*
HALT

Parameter(s):
MLP_NN_LM_HALT *cmd_in -- NML Message sent from superior.

Most Modules will have an HALT command.
The HALT function is expected to stop any motion or command execution,
send HALT commands to its subordinates,
wait for the subordinates to be DONE and then inform its superior that it is done.
The state tables should use the STATE_MATCH macro so the diagnostics tool can 
highlight the current line in the state table.
*/
void MLP_NN_LM_MODULE::HALT(MLP_NN_LM_HALT *cmd_in)
{
	// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

	// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


	if(STATE_MATCH(NEW_COMMAND))
	{
		//Send a HALT command to all subordinates.
		// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

		// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.

		stateNext(S1);
	}
	// Wait for all subordinates to report done.
	// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

	else if(STATE_MATCH(S1,
		1))
	// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.

	{
		status = RCS_DONE;
		stateNext(S2);
	}
	else if(STATE_MATCH(S2))
	{
		// Idle State
	}
}

/*
SET_ACTIVATION_FUNCTION_TYPE

Parameter(s):
MLP_NN_LM_SET_ACTIVATION_FUNCTION_TYPE *cmd_in -- NML Message sent from superior.

*/
void MLP_NN_LM_MODULE::SET_ACTIVATION_FUNCTION_TYPE(MLP_NN_LM_SET_ACTIVATION_FUNCTION_TYPE *cmd_in)
{
	// Put state table for MLP_NN_LM_SET_ACTIVATION_FUNCTION_TYPE here.
  if(STATE_MATCH(NEW_COMMAND))
    {
      status = RCS_EXEC;
      stateNext(S1);
    }
  else if(STATE_MATCH(S1))
    {
      mlp_lm->set_activation_function_type(cmd_in->activation_function_type);
      
      status = RCS_DONE;
      stateNext(S2);
    }
  else if(STATE_MATCH(S2))
    {
      // Idle State
    }
}

/*
SET_INPUT_BIASES

Parameter(s):
MLP_NN_LM_SET_INPUT_BIASES *cmd_in -- NML Message sent from superior.

*/
void MLP_NN_LM_MODULE::SET_INPUT_BIASES(MLP_NN_LM_SET_INPUT_BIASES *cmd_in)
{
	// Put state table for MLP_NN_LM_SET_INPUT_BIASES here.
  if(STATE_MATCH(NEW_COMMAND))
    {
      status = RCS_EXEC;
      stateNext(S1);
    }
  else if(STATE_MATCH(S1))
    {
      // Set the all the TS coefficients for the specified rule 
      mlp_lm->set_input_biases(cmd_in->low_bound, cmd_in->high_bound);

      status = RCS_DONE;
      stateNext(S2);
    }
  else if(STATE_MATCH(S2))
    {
      // Idle State
    }
}

/*
SET_INPUT_GAINS

Parameter(s):
MLP_NN_LM_SET_INPUT_GAINS *cmd_in -- NML Message sent from superior.

*/
void MLP_NN_LM_MODULE::SET_INPUT_GAINS(MLP_NN_LM_SET_INPUT_GAINS *cmd_in)
{
	// Put state table for MLP_NN_LM_SET_INPUT_GAINS here.
  if(STATE_MATCH(NEW_COMMAND))
    {
      status = RCS_EXEC;
      stateNext(S1);
    }
  else if(STATE_MATCH(S1))
    {
      // Set the all the TS coefficients for the specified rule 
      mlp_lm->set_input_gains(cmd_in->low_bound, cmd_in->high_bound);

      status = RCS_DONE;
      stateNext(S2);
    }
  else if(STATE_MATCH(S2))
    {
      // Idle State
    }
}

/*
SET_NONSINGULARITY_PARAM

Parameter(s):
MLP_NN_LM_SET_NONSINGULARITY_PARAM *cmd_in -- NML Message sent from superior.

*/
void MLP_NN_LM_MODULE::SET_NONSINGULARITY_PARAM(MLP_NN_LM_SET_NONSINGULARITY_PARAM *cmd_in)
{
	// Put state table for MLP_NN_LM_SET_NONSINGULARITY_PARAM here.
  if(STATE_MATCH(NEW_COMMAND))
    {
      status = RCS_EXEC;
      stateNext(S1);
    }
  else if(STATE_MATCH(S1))
    {
      mlp_lm->set_lambda(cmd_in->nonsingularity_param);
      
      status = RCS_DONE;
      stateNext(S2);
    }
  else if(STATE_MATCH(S2))
    {
      // Idle State
    }
}

/*
SET_OUTPUT_BIASES

Parameter(s):
MLP_NN_LM_SET_OUTPUT_BIASES *cmd_in -- NML Message sent from superior.

*/
void MLP_NN_LM_MODULE::SET_OUTPUT_BIASES(MLP_NN_LM_SET_OUTPUT_BIASES *cmd_in)
{
	// Put state table for MLP_NN_LM_SET_OUTPUT_BIASES here.
  if(STATE_MATCH(NEW_COMMAND))
    {
      status = RCS_EXEC;
      stateNext(S1);
    }
  else if(STATE_MATCH(S1))
    {
      // Set the all the TS coefficients for the specified rule 
      mlp_lm->set_output_biases(cmd_in->low_bound, cmd_in->high_bound);

      status = RCS_DONE;
      stateNext(S2);
    }
  else if(STATE_MATCH(S2))
    {
      // Idle State
    }
}

/*
SET_OUTPUT_GAINS

Parameter(s):
MLP_NN_LM_SET_OUTPUT_GAINS *cmd_in -- NML Message sent from superior.

*/
void MLP_NN_LM_MODULE::SET_OUTPUT_GAINS(MLP_NN_LM_SET_OUTPUT_GAINS *cmd_in)
{
	// Put state table for MLP_NN_LM_SET_OUTPUT_GAINS here.
  if(STATE_MATCH(NEW_COMMAND))
    {
      status = RCS_EXEC;
      stateNext(S1);
    }
  else if(STATE_MATCH(S1))
    {
      // Set the all the TS coefficients for the specified rule 
      mlp_lm->set_output_gains(cmd_in->low_bound, cmd_in->high_bound);

      status = RCS_DONE;
      stateNext(S2);
    }
  else if(STATE_MATCH(S2))
    {
      // Idle State
    }
}

/*
TEST

Parameter(s):
MLP_NN_LM_TEST *cmd_in -- NML Message sent from superior.

*/
void MLP_NN_LM_MODULE::TEST(MLP_NN_LM_TEST *cmd_in)
{
	// Put state table for MLP_NN_LM_TEST here.
  if(STATE_MATCH(NEW_COMMAND))
    {
      status = RCS_EXEC;
      stateNext(S1);
    }
  else if(STATE_MATCH(S1))
    {
      // Calculate the system output
      mlp_lm->test(sys_inputs, sys_outputs);
    }
  else if(STATE_MATCH(S2))
    {
      // Idle State
    }
}

/*
TRAIN

Parameter(s):
MLP_NN_LM_TRAIN *cmd_in -- NML Message sent from superior.

*/
void MLP_NN_LM_MODULE::TRAIN(MLP_NN_LM_TRAIN *cmd_in)
{
  // Put state table for MLP_NN_LM_TRAIN here.

  // Training a NN by a LM method is a batch process,
  // therefore, it is not very suitable for RCS applications
  // which work on cyclic processing and get new data each step.
  // For this reason, inherantly there is a difficulty here.
  // The implementation here firts waits until the needed data
  // is collected, and then starts the training.

  int ii; // For the loops
  static int data_num = 0;
  double nn_out_error, grad_norm;
  
  if(STATE_MATCH(NEW_COMMAND))
    {
      data_num = 0;

      status = RCS_EXEC;
      stateNext(S1);
    }
  else if(STATE_MATCH(S1))
    {
      // First collect all the batch data
      for(ii = 0; ii < num_of_inputs; ii++)
	{
	  batch_inputs[ii][data_num] = sys_inputs[ii];
	}
      for(ii = 0; ii < num_of_outputs; ii++)
	{
	  batch_ref_outputs[ii][data_num] = ref_outputs[ii];
	}
      data_num++;

      if(data_num == num_of_data)
	{
	  // Data collected -- move to the training process
	  stateNext(S2);
	}
    }
  else if(STATE_MATCH(S2))
    {
      // RCS works on cyclic processing, so perform one step
      // training each cycle. Otherwise, the training process
      // may not end within the cycle time.
      nn_out_error = mlp_lm->train_one_step(batch_inputs, batch_ref_outputs);

      // Calculate the regressor norm
      grad_norm = mlp_lm->get_norm_grad();

      if((nn_out_error < cmd_in->tolerance) || (grad_norm < cmd_in->min_grad_norm))
	{
	  status = RCS_DONE;
	  stateNext(S3);
	}
    }
  else if(STATE_MATCH(S3))
    {
      // Idle State
    }
}
